#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int prob_w = atoi(argv[1]);
	int prob_b = atoi(argv[2]);

	int n;
	cin >> n;
	string s, t;
	cin >> s >> t;
	vector<tuple<int, int, int, int>> edges;
	for (int i = 0; i < n; ++i) {
		edges.push_back({i, (i + 1) % n, i, 0});
		edges.push_back({i, n, i, 1});
	}

	vector<int> dsu(n + 1);
	iota(dsu.begin(), dsu.end(), 0);

	function<int(int)> get_root = [&](int v) {
		return dsu[v] == v ? v : dsu[v] = get_root(dsu[v]);
	};

	auto unite = [&](int a, int b) {
		a = get_root(a);
		b = get_root(b);
		if (a == b) {
			return false;
		}
		dsu[a] = b;
		return true;
	};

	reverse(edges.begin(), edges.end());
	shuffle(edges.begin(), edges.end());
	for (auto [a, b, pos, wh] : edges) {
		if (unite(a, b)) {
			if (rnd.next(prob_w + prob_b) < prob_w) {
				if (wh == 0) {
					s[pos] = 'W';
				} else {
					t[pos] = 'W';
				}
			} else {
				if (wh == 0) {
					s[pos] = 'B';
				} else {
					t[pos] = 'B';
				}
			}
		}
	}

	cout << n << "\n";
	cout << s << "\n" << t << "\n";

	return 0;
}