#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cstdio>

using namespace std;

void prefix_sum(vector<unsigned int> &count) {
    vector<unsigned int> pos = count;
    for (unsigned int i = 1; i < count.size(); i++) {
        pos[i] += pos[i - 1];
    }
    for (unsigned int i = 0; i < count.size(); i++) {
        count[i] = pos[i] - count[i];
    }
}

int main() {

#ifdef LOCAL
    freopen("tmp.in", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    string s;
    unsigned int k;
    cin >> s >> k;

    if (k <= 2) {
        if (k == 1) {
            char c = *min_element(s.begin(), s.end());
            cout << c << '\n';
        } else {
            auto c = min_element(s.begin(), s.end() - 1);
            cout << *c << *min_element(c + 1, s.end()) << '\n';
        }
        return 0;
    }

    unsigned int t = k - 2, alpha = 'z' - 'a' + 2;
    s.push_back('a' - 1);
    unsigned int n = s.length();
    unsigned int npow = 1u << (static_cast<unsigned int>(log2(n - 1)) + 1);

    vector<unsigned int> suf(n, 0);
    vector<unsigned int> claz(n, 0);
    vector<unsigned int> count(alpha, 0);

    for (unsigned int i = 0; i < n; i++) {
        count[s[i] + 1 - 'a']++;
    }
    prefix_sum(count);
    for (unsigned int i = 0; i < n; i++) {
        suf[count[s[i] + 1 - 'a']++] = i;
    }
    claz[suf[0]] = 0;
    for (unsigned int i = 1; i < n; i++) {
        claz[suf[i]] = claz[suf[i - 1]] + (s[suf[i]] == s[suf[i - 1]] ? 0 : 1);
    }

    for (unsigned int pow = 1; pow < npow; pow <<= 1u) {
        vector<int> second(n);
        for (unsigned int i = 0; i < n; i++) {
            second[i] = (suf[i] + n - pow) % n;
        }
        count = vector<unsigned int>(n + 1, 0);
        for (unsigned int i : second) {
            count[claz[i]]++;
        }
        prefix_sum(count);
        for (unsigned int i : second) {
            suf[count[claz[i]]++] = i;
        }

        vector<unsigned int> claz2(n, 0);
        claz2[suf[0]] = 0;
        for (unsigned int i = 1; i < n; i++) {
            claz2[suf[i]] = claz2[suf[i - 1]] + (claz[suf[i]] == claz[suf[i - 1]] &&
                                                 claz[(suf[i] + pow) % n] == claz[(suf[i - 1] + pow) % n] ? 0 : 1);
        }
        claz = claz2;
    }

    vector<unsigned int> lcp(n);
    vector<unsigned int> rev(n);
    for (int i = 0; i < n; i++) {
        rev[suf[i]] = i;
    }
    unsigned int lastlen = 0;

    for (unsigned int i = 0; i < n; i++) {
        if (lastlen > 0) {
            lastlen--;
        }
        if (rev[i] == n - 1) {
            lcp[n - 1] = -1;
            lastlen = 0;
        } else {
            int j = suf[rev[i] + 1];
            while (i + lastlen < n && j + lastlen < n && s[i + lastlen] == s[j + lastlen]) {
                lastlen++;
            }
            lcp[rev[i]] = lastlen;
        }
    }

    s.pop_back();
    n--;
    unsigned int from = n, loc = min_element(s.begin(), s.end() - t - 1) - s.begin();
    char start = s[loc];
    unsigned int idx = 0;
    for (unsigned int i = 0; i < n + 1; i++) {
        if (suf[i] > loc && suf[i] + t < n) {
            from = suf[i];
            idx = i;
            break;
        }
    }
    while (lcp[idx] >= t) {
        if (suf[idx] > loc && suf[idx] + t < n) {
            from = min(from, suf[idx++]);
        } else {
            idx++;
        }
    }
    char stop = *min_element(s.begin() + from + t, s.end());

    cout << start;
    for (unsigned int i = 0; i < t; i++) {
        cout << s[from + i];
    }
    cout << stop << '\n';

    return 0;

}
