// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998244353;
const int P = 239;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

void solve() {
	string s;
	cin >> s;
	vector<int> arrh = {0};
	for (char c : s) {
		arrh.push_back(sum(mult(arrh.back(), 239), c));
	}

	vector<int> arrp = {1};
	for (int i = 0; i < szof(s) + 5; ++i) {
		arrp.push_back(mult(arrp.back(), P));
	}

	auto get_hash = [&](int l, int r) {
		return sum(arrh[r], MOD - mult(arrh[l], arrp[r - l]));
	};

	int n = szof(s);
	int k;
	cin >> k;
	if (k == 1) {
		cout << *min_element(s.begin(), s.end()) << "\n";
		return;
	}
	int l = -1, cl = -1, cr = -1, r = -1;
	int mem = 0;
	vector<int> suff(n);
	suff[n - 1] = n - 1;
	for (int i = n - 2; i >= 0; --i) {
		suff[i] = suff[i + 1];
		if (s[i] < s[suff[i]]) {
			suff[i] = i;
		}
	}
	auto cmp = [&](int l1, int cl1, int cr1, int r1, int l2, int cl2, int cr2, int r2) {
		if (l2 == -1) {
			return true;
		}
		if (s[l1] != s[l2]) {
			return s[l1] < s[l2];
		}
		int lg = 0, rg = k - 1;
		while (rg - lg > 1) {
			int mid = (lg + rg) / 2;
			if (get_hash(cl1, cl1 + mid) == get_hash(cl2, cl2 + mid)) {
				lg = mid;
			} else {
				rg = mid;
			}
		}
		if (lg < k - 2) {
			return s[cl1 + lg] < s[cl2 + lg];
		}
		return s[r1] < s[r2];
	};
	for (int i = 1; i + k - 1 <= szof(s); ++i) {
		if (s[i - 1] < s[mem]) {
			mem = i - 1;
		}
		if (cmp(mem, i, i + k - 2, suff[i + k - 2], l, cl, cr, r)) {
			l = mem; cl = i; cr = i + k - 2; r = suff[i + k - 2];
		}
	}

	cout << s[l] << s.substr(cl, k - 2) << s[r] << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
