#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int MAXN = 100'000;
const int MAXM = 150'000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(0, MAXM, "m");
	inf.readEoln();

	set<pii> edges;
	vector<vector<int>> graph(n);

	for (int i = 0; i < m; ++i) {
		int a = inf.readInt(1, n, format("a_%d", i + 1)) - 1;
		inf.readSpace();
		int b = inf.readInt(1, n, format("b_%d", i + 1)) - 1;
		inf.readEoln();
		ensuref(a != b, "graph shouldn't contain loops");
		if (a > b) {
			swap(a, b);
		}
		ensuref(!edges.count({a, b}), "graph shouldn't contain multiple edges");
		edges.insert({a, b});
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	inf.readEof();

	vector<int> used(n);

	vector<int> cnt(n);
	function<int(int, int)> dfs = [&](int v, int p) {
		int ret = 0;
		used[v] = 1;
		for (int to : graph[v]) {
			if (!used[to]) {
				ret += dfs(to, v);
			} else if (used[to] == 1 && to != p) {
				cnt[to]++;
				ret++;
			}
		}
		ret -= cnt[v];
		ensuref(ret <= 1, "graph should be a cactus, but edge (%d - %d) belongs to at least two cycles", p + 1, v + 1);
		used[v] = 2;
		return ret;
	};

	dfs(0, 0);

	for (int i = 0; i < n; ++i) {
		ensuref(used[i], "graph should be connected");
	}

	return 0;
}