// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> graph(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	vector<int> used(n);
	vector<vector<vector<int>>> dp(n, vector<vector<int>>(3, vector<int>(4, INF)));
	vector<int> depth(n);
	vector<int> up(n);

	function<void(int, int, int)> dfs = [&](int v, int p, int d) {
		depth[v] = d;
		used[v] = 1;
		up[v] = v;
		vector<int> cur(8, INF);
		cur[0] = 0;
		int mem = -1;
		for (int to : graph[v]) {
			if (!used[to]) {
				dfs(to, v, d + 1);
				if (depth[up[to]] < depth[v]) {
					up[v] = up[to];
					mem = to;
				} else {
					vector<int> next(8, INF);
					for (int old_mask = 0; old_mask < 8; ++old_mask) {
						for (int col1 = 0; col1 < 3; ++col1) {
							for (int col2 = 0; col2 < 4; ++col2) {
								int new_mask = old_mask | (1 << col1);
								if (col2 < 3) {
									new_mask |= 1 << col2;
								}
								next[new_mask] = min(next[new_mask], cur[old_mask] + dp[to][col1][col2]);
							}
						}
					}
					swap(cur, next);
				}
			} else if (used[to] == 1 && to != p) {
				// cerr << "up edge " << v + 1 << " " << to + 1 << endl;
				up[v] = to;
				mem = -2;
			}
		}
		if (mem == -2) {
			for (int mask = 0; mask < 8; ++mask) {
				for (int col = 0; col < 3; ++col) {
					if (mask & (1 << col)) {
						continue;
					}
					dp[v][col][col] = min(dp[v][col][col], cur[mask] + (col == 2));
				}
			}
		} else if (mem == -1) {
			for (int mask = 0; mask < 8; ++mask) {
				for (int col = 0; col < 3; ++col) {
					if (mask & (1 << col)) {
						continue;
					}
					dp[v][col][3] = min(dp[v][col][3], cur[mask] + (col == 2));
				}
			}
		} else {
			for (int mask = 0; mask < 8; ++mask) {
				for (int col1 = 0; col1 < 3; ++col1) {
					if (mask & (1 << col1)) {
						continue;
					}
					for (int col2 = 0; col2 < 3; ++col2) {
						if (col2 == col1) {
							continue;
						}
						for (int col3 = 0; col3 < 3; ++col3) {
							dp[v][col1][col3] = min(dp[v][col1][col3], dp[mem][col2][col3] + cur[mask] + (col1 == 2));
						}
					}
				}
			}
		}
		// cerr << "v: " << v + 1 << endl;
		// for (int i = 0; i < 3; ++i) {
		// 	for (int j = 0; j < 4; ++j) {
		// 		cerr << dp[v][i][j] << " ";
		// 	}
		// 	cerr << endl;
		// }
		used[v] = 2;
	};

	dfs(0, 0, 0);
	int ans = INF;
	for (int i = 0; i < 3; ++i) {
		for (int j = 0; j < 4; ++j) {
			ans = min(ans, dp[0][i][j]);
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
