///created by Arsenii Kirillov
#ifdef DEBUG
# define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int) (x).size())

template <typename T>
T input() {
    T res;
    std::cin >> res;
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()


using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
mt19937 tw(228);
ll rnd(ll l, ll r) { return tw() % (r - l + 1) + l; }

const int mod = 998244353;

struct matrix
{
	int n, m;
	vector<vector<int> > mas;
	matrix(int n_ = 0, int m_ = 0, int fill_ = 0)
	{
		n = n_;
		m = m_;
		mas = vector<vector<int> >(n, vector<int>(m, fill_));
	}
	matrix operator *(matrix a)
	{
		assert(m == a.n);
		matrix ans(n, a.m);
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < a.m; j++)
			{
				for (int q = 0; q < m; q++)
				{
					ans.mas[i][j] = (ans.mas[i][j] + (long long)mas[i][q] * a.mas[q][j]) % mod;
				}
			}
		}
		return ans;
	}
};

matrix poww(matrix a, long long n)
{
	assert(a.n == a.m);
	matrix ans(a.n, a.n);
	for (int i = 0; i < a.n; i++)
		ans.mas[i][i] = 1;
	while (n)
	{
		if (n & 1)
			ans = ans * a;
		a = a * a;
		n /= 2;
	}
	return ans;
}

void solve() {
	long long n;
	cin >> n;
	if (n == 0)
	{
		cout << 1 << endl;
		return;
	}
	matrix a(4, 4);
	a.mas[0][0] = 1;
	a.mas[2][0] = 2;
	a.mas[1][0] = 1;
	a.mas[0][1] = 1;
	a.mas[0][2] = 1;
	a.mas[2][2] = 1;
	a.mas[0][3] = 1;
	a.mas[2][3] = 2;
	a.mas[1][3] = 1;
	a.mas[3][3] = 1;
	matrix st(1, 4);
	st.mas[0][0] = 1;
	st.mas[0][1] = 1;
	st.mas[0][2] = 1;
	st.mas[0][3] = 2;
	matrix fi = st * poww(a, n - 1);
	cout << fi.mas[0][3] << endl;
}

int main() {
    cout << fixed << setprecision(15);
    cerr << fixed << setprecision(15);
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }

#ifdef LOCAL
    cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}