#include <bits/stdc++.h>
using namespace std;

const int A =  ('z' - 'a' + 1);
const int P = 43;
const int M = int(1e9) + 7;

vector<long long> powP;

vector<long long> calcHash(const vector<int> &s)
{
    vector<long long> h(s.size());
    h[0] = s[0];
    for (int i = 1; i < int(s.size()); i++)
        h[i] = (h[i - 1] * P + s[i]) % M;
    return h;
}

long long getHash(vector<long long> &h, int l, int r)
{
    if (r < 0)
        return 0;
    if (l == 0)
        return h[r];
    return (M + h[r] - (h[l - 1] * powP[r - l + 1]) % M) % M;
}

int main()
{
    int n;
    cin >> n;
    string s, t;
    cin >> s >> t;
    vector<int> ds(n), dt(2 * n);
    for (int i = 0; i < n; i++)
    {
        ds[i] = (A + s[i] - s[(i + 1) % n]) % A + 1;
        dt[i] = (A + t[i] - t[(i + 1) % n]) % A + 1;
    }
    for (int i = n; i < 2 * n; i++)
        dt[i] = (A + t[i % n] - t[(i + 1) % n]) % A + 1;
    powP.resize(2 * n, 1);
    for (int i = 1; i < 2 * n; i++)
        powP[i] = (powP[i - 1] * P) % M;
    vector<long long> hs = calcHash(ds);
    vector<long long> ht = calcHash(dt);
    long long hashS = getHash(hs, 0, n - 1);
    for (int i = 0; i < n; i++)
    {
        long long hashT = getHash(ht, i, i + n - 1);
        if (hashT == hashS)
        {
            cout << "Success" << endl;
            cout << i << ' '  << t[i] - s[0] << endl;
            return 0;
        }
    }
    cout << "Impossible" << endl;
    return 0;
}