#include "testlib.h"
#include <iostream>

using namespace std;
typedef long long ll;

const ll MAXV = 1'000'000'000'000'000'000;

int main(int argc, char *argv[]) {
    setName("bank interactor");
    registerInteraction(argc, argv);

    long long n = inf.readLong(), left = n;
    int max_queries_amount = 0;
    while (1ll << max_queries_amount < n) {
        ++max_queries_amount;
    }
    max_queries_amount += 10;
    int queries = 0;

    vector<string> interaction_protocol = {"interaction protocol:"};

    auto print_protocol = [&]() {
        for (auto s : interaction_protocol) {
            tout << s << "\n";
        }
    };

    while (true) {
        string type = ouf.readToken("withdraw|finish");
        
        if (type == "withdraw") {
            long long val = ouf.readLong(1, MAXV);
            interaction_protocol.push_back(format("withdraw %lld", val));
            ++queries;
            if (queries > max_queries_amount) {
                cout << "fail" << endl;
                interaction_protocol.push_back("fail");
                print_protocol();
                quitf(_wa, "too many queries");
            }
            if (val <= left) {
                cout << "accepted" << endl;
                interaction_protocol.push_back("accepted");
                left -= val;
            } else {
                cout << "rejected" << endl;
                interaction_protocol.push_back("rejected");
            }
        } else if (type == "finish") {
            interaction_protocol.push_back("finish");
            if (left == 0) {
                tout << "correct\n" << format("%d/%d requests made, initialy there was $%lld", queries, max_queries_amount, n) << "\n";
            } else {
                tout << "incorrect\n" << format("%d/%d requests made, there're left $%lld", queries, max_queries_amount, left) << "\n";
            }
            print_protocol();
            quitf(_ok, "interaction finished");
        } else {
            quitf(_fail, "something went wrong");
        }
    }
}