#include <iostream>
#include <vector>
#include <set>

using namespace std;

struct edge {

    unsigned int to;
    unsigned long long a, b;
    unsigned long long d;

};

int main() {

    unsigned int n, m, s, t;
    cin >> n >> m >> s >> t;
    s--;
    t--;

    vector<vector<edge>> graph(n);
    for (unsigned int i = 0; i < m; i++) {
        unsigned int u, v;
        unsigned long long a, b, d;
        cin >> u >> v >> a >> b >> d;
        u--;
        v--;
        graph[u].push_back(edge{v, a, b, d});
        graph[v].push_back(edge{u, a, b, d});
    }

    unsigned long long limit = 1e18;
    vector<unsigned long long> time(n, limit);
    time[s] = 0;

    typedef pair<unsigned int, unsigned long long> item;
    auto cmp = [](item const &l, item const &r) {
        return l.second < r.second;
    };
    set<item, decltype(cmp)> nodes(cmp);
    for (unsigned int i = 0; i < n; i++) {
        nodes.insert(make_pair(i, time[i]));
    }
    while (!nodes.empty()) {
        auto last = *nodes.begin();
        nodes.erase(nodes.begin());
        for (auto const &e : graph[last.first]) {
            if (e.a >= e.d) {
                unsigned long long p = e.a + e.b;
                unsigned long long tau = last.second % p;
                unsigned long long start = tau <= e.a ? last.second : last.second - tau + p;
                if (start + e.d < time[e.to]) {
                    nodes.erase(make_pair(e.to, time[e.to]));
                    time[e.to] = start + e.d;
                    nodes.insert(make_pair(e.to, time[e.to]));
                }
            }
        }
    }

    cout << (time[t] == limit ? -1 : (long long) time[t]) << '\n';

}