// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m, s, t;
	cin >> n >> m >> s >> t;
	--s; --t;
	vector<vector<tuple<int, int, int, int>>> graph(n);
	for (int i = 0; i < m; ++i) {
		int a, b, t1, t2, t3;
		cin >> a >> b >> t1 >> t2 >> t3;
		--a; --b;
		graph[a].push_back({b, t1, t2, t3});
		graph[b].push_back({a, t1, t2, t3});
	}
	vector<ll> dist(n, INFL);
	dist[s] = 0;
	set<pair<ll, int>> st;
	st.insert({0, s});
	while (szof(st)) {
		int v = st.begin()->ss;
		if (v == t) {
			break;
		}
		st.erase(st.begin());
		for (auto [to, t1, t2, t3] : graph[v]) {
			if (t3 > t1) {
				continue;
			}
			ll val;
			ll tmp = dist[v] % (t1 + t2);
			if (tmp + t3 <= t1) {
				val = dist[v];
			} else {
				val = (dist[v] / (t1 + t2) + 1) * (t1 + t2);
			}
			val += t3;
			if (dist[to] > val) {
				st.erase({dist[to], to});
				dist[to] = val;
				st.insert({dist[to], to});
			}
		}
	}
	if (dist[t] == INFL) {
		cout << "-1\n";
	} else {
		cout << dist[t] << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
